package com.ruoyi.web.controller.pc;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.domain.resp.PlatformDayPlanResp;
import com.ruoyi.system.domain.resp.WeekMonthPersonCountResp;
import com.ruoyi.system.service.impl.PlatformService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;


/**
 * @Author zhuqing
 * @Date 2022/8/9
 * 工作台
 */
@RestController
@RequestMapping("/platform")
@Api("工作台")
public class PlatformController {

    @Autowired
    private PlatformService platformService;

    @ApiOperation("工作台-设备统计")
    @PostMapping("/equCount")
    public AjaxResult equCount(
            @ApiParam(name = "hospitalId",value = "医院id",required = false) @RequestParam(required = false) Long hospitalId,
            @ApiParam(name = "doctorId",value = "医生id",required = false) @RequestParam(required = false) Long doctorId){
        Map<String, Integer> stringIntegerMap = platformService.equCount(hospitalId, doctorId);
        return AjaxResult.success(stringIntegerMap);
    }

    @ApiOperation("工作台-今日就诊计划")
    @PostMapping("/dayPlan")
    public AjaxResult dayPlan(
            @ApiParam(name = "hospitalId",value = "医院id",required = false) @RequestParam(required = false) Long hospitalId,
            @ApiParam(name = "doctorId",value = "医生id",required = false) @RequestParam(required = false) Long doctorId){
        List<PlatformDayPlanResp> platformDayPlanResps = platformService.dayPlan(hospitalId, doctorId);
        return AjaxResult.success(platformDayPlanResps);
    }

    @ApiOperation("工作台-就诊人数统计")
    @PostMapping("/weekMonthPersonCount")
    public AjaxResult weekMonthPersonCount(
            @ApiParam(name = "hospitalId",value = "医院id",required = false) @RequestParam(required = false) Long hospitalId,
            @ApiParam(name = "doctorId",value = "医生id",required = false) @RequestParam(required = false) Long doctorId,
            @ApiParam(name = "weekMonth",value = "周月的区分 1-周 2-月",required = false) @RequestParam(required = false) Long weekMonth){
        List<WeekMonthPersonCountResp> weekMonthPersonCountResps = platformService.weekMonthPersonCount(hospitalId, doctorId,weekMonth);
        return AjaxResult.success(weekMonthPersonCountResps);
    }

    @ApiOperation("工作台-患者年龄统计")
    @PostMapping("/ageCount")
    public AjaxResult ageCount(
            @ApiParam(name = "hospitalId",value = "医院id",required = false) @RequestParam(required = false) Long hospitalId,
            @ApiParam(name = "doctorId",value = "医生id",required = false) @RequestParam(required = false) Long doctorId){
        Map<String,Long> map = platformService.ageCount(hospitalId,doctorId);
        return AjaxResult.success(map);
    }

    @ApiOperation("工作台-就诊时段统计")
    @PostMapping("/weekMonthTimeCount")
    public AjaxResult weekMonthTimeCount(
            @ApiParam(name = "hospitalId",value = "医院id",required = false) @RequestParam(required = false) Long hospitalId,
            @ApiParam(name = "doctorId",value = "医生id",required = false) @RequestParam(required = false) Long doctorId,
            @ApiParam(name = "weekMonth",value = "周月的区分 1-周 2-月",required = false) @RequestParam(required = false) Long weekMonth){
        Map<String,Integer> weekMonthPersonCountResps = platformService.weekMonthTimeCount(hospitalId, doctorId,weekMonth);
        return AjaxResult.success(weekMonthPersonCountResps);
    }

}
